RecentChanges legend overlaps actual RecentChanges
Closed, ResolvedPublic

Description

When 'Group results by page' option is used on RC or Watchlist page, the legend overlaps actual result set.
Compare:

  • 'Group results by page' option is not enabled

  • 'Group results by page' option is enabled

Legoktm created this task.Dec 5 2017, 11:08 PM
Nirmos added a subscriber: Nirmos.Dec 6 2017, 10:13 AM

FWIW, I can't reproduce this. Have you tried safemode? Also, you say RecentChanges but the screenshot shows Watchlist.

I can reproduce on mw and beta.wmflabs (i.e. with 1.31.0-wmf.11) in any skin.

Schnark renamed this task from RecentChanges legend overlaps actual RecentChanges in Timeless skin to RecentChanges legend overlaps actual RecentChanges.Dec 6 2017, 11:10 AM
Schnark edited projects, added Regression; removed Timeless.
Nirmos added a comment.Dec 8 2017, 7:05 AM

Found it. "Group changes by page in recent changes and watchlist" at Special:Preferences#mw-prefsection-rc causes this.

Isarra added a comment.Dec 8 2017, 4:47 PM

That preference isn't exactly new, though.

And yet, it's been ignored in almost every RC update in the last year - I remember at least 2 other bugs that were only reproducible with that setting. Better regression testing should probably be a target, but oh well...

Catrope added a subscriber: Catrope.Dec 8 2017, 6:09 PM

Looks like this is specific to the Timeless skin?

Hmm not really, it's just that in Vector the results area is much wider and the results aren't usually wide enough to be overlapped by the legend, but it can happen. This is because the legend was recently changed to be absolutely positioned (cc @Petar.petkovic)

This is actually what's supposed to happen, after this change bc3f4d1b1860.
Legend becomes absolutely positioned when grouping results by page is enabled. You can easily see this by clicking button that says "1,000 changes, 30 days" and choosing "Group results by page", no need for preference to see how legend becomes absolutely positioned.

The overlap which was not intended (fixed, but not yet in production) is described here: T182269.

The issue happens in all skins when, as @Nirmos pointed out:

"Group changes by page in recent changes and watchlist" at Special:Preferences#mw-prefsection-rc causes this.

@Strainu - I agree with

Better regression testing should probably be a target, but oh well...

Can you give specific links for ?

And yet, it's been ignored in almost every RC update in the last year - I remember at least 2 other bugs that were only reproducible with that setting.

Strainu added a comment.EditedDec 8 2017, 9:23 PM

Can you give specific links for ?

And yet, it's been ignored in almost every RC update in the last year - I remember at least 2 other bugs that were only reproducible with that setting.

Sure!

T164059; T125858 are the ones reported on the ro.wiki village pump, there might have been others that haven't been reported there.

T29436 is not technically a regression, but still a nuisance and something that has clearly not been tested with that setting;

I understand that some of them were done by 3rd party teams, but the team responsible for RC should have the means to catch such issues.

Thx, @Strainu I will re-check those task and re-triage them if necessary.

Xaosflux triaged this task as Normal priority.Dec 11 2017, 12:37 PM

@Strainu

@Etonkovidova, thanks a lot for taking another look at those issues, this is really nice of you :) You might have misunderstood my main complaint, though: the bugs seem to have appeared in production due to a lack of testing with the "Group changes" option when introducing new features (labels, wikidata, etc.) and this situation seems to repeat itself for a while already. The solutions I see is to either have a release criteria for RC-related tasks on the lines of "test with option X, Y, Z..." or introduce automated tests that can detect differences between the output of the RC feed with various options enabled and continuously improve the tests when new bugs appear (aka the better regression I was talking about). The latter seems preferable to me, although it probably requires a significant time investment upfront.

Since the issue is not specific to the skin, but specific to the 'Group results by page' option, I am updating the task description and moving it to Collab-Team-This-Quarter workboard.

What is the expected outcome of this ticket at this point? I already wrote that overlapping behavior is expected.

The thing specific to skin(s) is right alignment of legend (probably different parent with position: relative compared to Vector skin).

@Petar.petkovic The expected behavior: the expanded Legend should behave the same whether 'Group results by page' option is enabled or not. Presently, if the option is not enabled, the long lines in the result set will wrap and the legend won't overlap the text. This is the desirable behavior.

@Petar.petkovic The expected behavior: the expanded Legend should behave the same whether 'Group results by page' option is enabled or not. Presently, if the option is not enabled, the long lines in the result set will wrap and the legend won't overlap the text. This is the desirable behavior.

I know how different cases (with and without grouping) behave. It was done on purpose, because results are displayed differently when there is grouping, compared to case without grouping. That difference in how results are displayed causes different wrapping around the expanded legend.

Grouped results don't wrap the same way non-grouped results do, and always leave the white space around the legend, pushing few results sometimes too much. This was changed as part of T174728: "Legend" retains some space if "Group results by change" is enabled.

So, as a trade-off, legend is now above results, with a box shadow to indicate so.

@Petar.petkovic Having elements overlap for whatever reason makes the page look broken. If there is really no way to solve both bugs, I would suggest that the situation described in T174728 is better than the current one.

Just another screenshot to show that this isn't just a minor nuisance:

Even when I collapse the legend, it still overlaps important links.

So....how do we fix this? Is there a straightforward revert that can be made? This is pretty annoying :(

So....how do we fix this? Is there a straightforward revert that can be made? This is pretty annoying :(

Yes, there should be straightforward way to revert. I will probably provide reverting patch tomorrow.

Change 408712 had a related patch set uploaded (by Petar.petkovic; owner: Petar.petkovic):
[mediawiki/core@master] Revert legend when results are grouped

https://gerrit.wikimedia.org/r/408712

Change 408712 merged by jenkins-bot:
[mediawiki/core@master] Revert legend when results are grouped

https://gerrit.wikimedia.org/r/408712

Checked in betalabs - the Legend does not overlap the result set anymore with the 'Group results by page' option enabled.

Specifically for Timeless skin:



QA Recommendation: Resolve

This comment was removed by Trizek-WMF.